<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Bitrix24 storage API example</title>
    <style>
        textarea {
            width: 100%;
            height: 10em;
            box-sizing: border-box;
        }
        div {
            box-sizing: border-box;
        }
        #jsinput {
            width: 100%;
            height: 10em;
            box-sizing: border-box;
        }
        #output {
            border: 1px dashed black;
            padding: 1em;
            width: 100%;
            overflow: auto;
            box-sizing: border-box;
        }
        
        #main {
            border: 1px solid black;
            padding: 1em;
            overflow: auto;
        }
    </style>
</head>
<body>
    <div id="main"></div>
    
    <div><button id="btn-records">Записи</button></div>
    <br>
    <div>
        <b>Добавить запись</b><br>
        <input type="text" id="add-rec-stor" placeholder="Storage ID" required>
        <input type="text" id="add-rec-sec" placeholder="Section ID" required>
        <input type="text" id="add-rec-name" placeholder="Item name" required><br>
        <textarea id="add-rec-data" placeholder="Data in JSON format"></textarea><br>
        <button id="add-rec-btn">Добавить</button>
    </div>
    <br>
    
    <div>
        <b>Добавить хранилище</b>
        <input type="text" id="add-stor-id" placeholder="Storage ID" required>
        <input type="text" id="add-stor-name" placeholder="Storage Name" required><br>
        <textarea id="add-stor-props" placeholder="Storage properties (JSON):
        {&quot;propID&quot;: &quot;propName&quot;}" required></textarea><br>
        <button id="add-stor-btn">Добавить</button>
    </div>
    <br>

    <div>
        <b>Добавить раздел (секцию)</b>
        <input type="text" id="add-sec-id" placeholder="Storage ID" required>
        <input type="text" id="add-sec-name" placeholder="Section name" required>
        <button id="add-sec-btn">Добавить</button>
    </div>
    <br>
    
    <textarea id="jsinput" placeholder="Input JS">// Выполнить JavaScript</textarea><br>
    <button id="btn-run">Run</button>
    <pre id="output"></pre>
    
        
    
    <script src="//api.bitrix24.com/api/v1/"></script>
    <script>
        // Make a call to REST when JS SDK is loaded
        BX24.init(function(){
            console.log('B24 SDK is ready!', BX24.isAdmin());
        });
        
        var UI = new function() {
            //this.els = {};
            this.output = document.getElementById('output');
            this.btnRun = document.getElementById('btn-run');
            this.jsinput =  document.getElementById('jsinput'),
            this.main = document.getElementById('main');
            this.btnRecords = document.getElementById('btn-records');
            this.btnAddRec = document.getElementById('add-rec-btn');
            this.addRecStor = document.getElementById('add-rec-stor');
            this.addRecSec = document.getElementById('add-rec-sec');
            this.addRecData = document.getElementById('add-rec-data');
            this.addRecName = document.getElementById('add-rec-name');
            this.get = function(sel) {
                //if (typeof this.els[sel] === 'undefined')
                //    this.els[sel] = document.querySelector(sel);
                //return this.els[sel];
                return document.querySelector(sel);
            };
            this.output.print = function(data, append=false) {
                if (typeof data === 'object')
                    data = JSON.stringify(data);
                if (append)
                    output.innerHTML += data;
                else
                    output.innerHTML = data;
            };
            this.HTMLElement = function(HTML) {
                var template = document.createElement('template');
                template.innerHTML = HTML;
                return template.content.childNodes[0];
            };
        } // UI object
        
        
        // Run JS code
        UI.btnRun.addEventListener('click', function(e) {
            var result = eval(UI.jsinput.value);
            UI.output.print(result);
            console.log(result);
        }, false);
        
        UI.get('#add-stor-btn').addEventListener('click', function(e){
            BX24.callMethod('entity.add', {
                'ENTITY': UI.get('#add-stor-id').value,
                'NAME': UI.get('#add-stor-name').value,
                //'ACCESS': {U1:'W',AU:'R'}
            }, function(result) {
                var error = result.error();
                if(!error) {
                    UI.output.print(result);
                    UI.output.print('\nAddig props:\n', true);
                    var props = JSON.parse(UI.get('#add-stor-props').value);
                    if (typeof props === 'object') {
                        var pks = Object.keys(props);
                        for (var i=0; i<pks.length; i++) {
                            BX24.callMethod('entity.item.property.add', {ENTITY: UI.get('#add-stor-id').value, PROPERTY: pks[i], NAME: props[pks[i]], TYPE: 'S'}, function(result){
                                UI.output.print(result + '\n', true);
                            });
                        }
                    }
                }
            });
        }, false); // add new storage
        
        
        UI.get('#add-sec-btn').addEventListener('click', function(e){
            BX24.callMethod('entity.section.add', {ENTITY: UI.get('#add-sec-id').value, 'NAME': UI.get('#add-sec-name').value}, function(result) {
                UI.output.print(result);
            });
        }, false);
        
        // Add record
        UI.btnAddRec.addEventListener('click', function(e) {
            BX24.callMethod('entity.item.add', {
                    ENTITY: UI.addRecStor.value,
                    NAME: UI.addRecName.value,
                    PROPERTY_VALUES: UI.addRecData.value ? JSON.parse(UI.addRecData.value) : {},
                    SECTION: UI.addRecSec.value
                }, function(result) {
                    UI.output.print(result);
                });
        });
        
        
        // get all records
        UI.btnRecords.addEventListener('click', function(e) {
            var entities;
            var sections;
            UI.main.innerHTML = '';
            BX24.callMethod("entity.get", {},
                function(result)
                {
                    var error = result.error();
                    if(error) {
                        console.error(error);
                        UI.output.print(error);
                    }
                    else
                    {
                        entities = result.data();
                        var ul = document.createElement('ul');
                        UI.main.append(ul);
                        for (var i=0; i<entities.length; i++) {
                            var ent = entities[i];
                            var li = UI.HTMLElement('<li id="ent'+ent.ENTITY+'">Хранилище '+ent.ENTITY+': '+ent.NAME+'</li>');
                            ul.append(li);
                            
                            BX24.callMethod('entity.section.get', {ENTITY: ent.ENTITY}, function(result){
                                sections = result.data();
                                if (sections.length > 0) {
                                    var secUl = document.createElement('ul');
                                    UI.get('#ent'+sections[0].ENTITY).append(secUl);
                                    //console.log('ENT:', sections[0].ENTITY, 'SECTIONS:', sections);
                                    for (var j=0; j<sections.length; j++) {
                                        var sec = sections[j];
                                        var li = UI.HTMLElement('<li id="sec'+sec.ID+'">Секция '+sec.ID+': '+sec.NAME+'</li>');
                                        secUl.append(li);
                                        BX24.callMethod('entity.item.get', {
                                            ENTITY: sec.ENTITY,
                                            FILTER: {
                                                '=SECTION': sec.ID,
                                            }
                                        }, function(result) {
                                            var items = result.data();
                                            if (items.length > 0) {
                                                var itemsUl = document.createElement('ul');
                                                UI.get('#sec'+items[0].SECTION).append(itemsUl);
                                                for (var k=0; k<items.length; k++) {
                                                    var item = items[k];
                                                    var li = UI.HTMLElement('<li id="item'+item.ID+'">Item '+item.ID+': '+item.NAME+'<br>'+
                                                    JSON.stringify(item) + '</li>');
                                                    itemsUl.append(li);
                                                } // for items
                                            } //  if items
                                        });
                                    } // for sections
                                } // if sections
                            }); // sections result
                        } // for enttities
                    } //if entities result
                }
            );
        }, false); // show all storage
    </script>
</body>
</html>
